<template>
  <div ref="container" class="container">
    <div class="scroll-box">
      <slot></slot>
    </div>
  </div>
</template>

<script>
export default {
  methods: {
    updateContainerSize() {
      const container = this.$refs.container;
      if (!container) return false;
      const box = container.querySelector(".scroll-box");
      if (!box) return false;
      container.style.height = `${box.offsetHeight - 30}px`;
      return true;
    }
  },

  mounted() {
    this.observer = new ResizeObserver(entries => {
      this.updateContainerSize();
    });
    const container = this.$refs.container;
    if (container) this.observer.observe(container);
  },

  destroyed() {
    this.observer.disconnect();
  }
};
</script>

<style lang="scss" scoped>
.container {
  overflow: hidden;
}

.scroll-box {
  height: auto;
  display: flex;
  flex-direction: row;
  overflow-x: scroll;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;
  scroll-snap-type: x mandatory;
}
</style>
